'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _editor = require('./editor');

var _editor2 = _interopRequireDefault(_editor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Usage:
//
// <Phone
// 	value={this.state.phone}
// 	format={formats.RU}
// 	onChange={phone => this.setState({ phone })}
// 	className=".phone-input"
// 	style={{ color: 'black' }} />
//

var Phone_input = function (_React$Component) {
	(0, _inherits3.default)(Phone_input, _React$Component);

	function Phone_input(props, context) {
		(0, _classCallCheck3.default)(this, Phone_input);

		var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Phone_input).call(this, props, context));

		_this.onKeyDown = _this.onKeyDown.bind(_this);
		_this.format_input_value = _this.format_input_value.bind(_this);
		return _this;
	}

	(0, _createClass3.default)(Phone_input, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props;
			var className = _props.className;
			var style = _props.style;


			return _react2.default.createElement('input', {
				type: 'tel',
				ref: 'input',
				value: this.props.value,
				onKeyDown: this.onKeyDown,
				onChange: function onChange(event) {
					return _this2.format_input_value();
				},
				onPaste: function onPaste(event) {
					return _this2.format_input_value();
				},
				onCut: function onCut(event) {
					return _this2.format_input_value({ delete: true });
				},
				className: className,
				style: style });
		}

		// Sets <input/> value and caret position

	}, {
		key: 'set_input_value',
		value: function set_input_value(value, caret_position) {
			// DOM Node
			var input = _reactDom2.default.findDOMNode(this.refs.input);

			input.value = value;

			if (this.props.onChange) {
				this.props.onChange(value);
			}

			// Set caret position (with the neccessary adjustments)
			if (caret_position !== undefined) {
				input.setSelectionRange(caret_position, caret_position);
			}
		}

		// Gets <input/> value

	}, {
		key: 'get_input_value',
		value: function get_input_value() {
			// DOM Node
			var input = _reactDom2.default.findDOMNode(this.refs.input);

			return input.value;
		}

		// Gets <input/> caret position

	}, {
		key: 'get_caret_position',
		value: function get_caret_position() {
			// DOM Node
			var input = _reactDom2.default.findDOMNode(this.refs.input);

			return input.selectionStart;
		}

		// Gets <input/> selected position

	}, {
		key: 'get_selection',
		value: function get_selection() {
			// DOM Node
			var input = _reactDom2.default.findDOMNode(this.refs.input);

			if (input.selectionStart === input.selectionEnd) {
				return;
			}

			return { start: input.selectionStart, end: input.selectionEnd };
		}

		// Formats input value as a phone number

	}, {
		key: 'format_input_value',
		value: function format_input_value() {
			var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

			// Get selection position
			options.selection = this.get_selection();

			// Edit <input/>ted value according to the input conditions (caret position, key pressed)

			var _edit = (0, _editor2.default)(this.get_input_value(), this.get_caret_position(), this.props.format, options);

			var phone = _edit.phone;
			var caret = _edit.caret;

			// Set <input/> value and caret position

			this.set_input_value(phone, caret);
		}
	}, {
		key: 'onKeyDown',
		value: function onKeyDown(event) {
			var key = event.keyCode;
			// If the keys include the CTRL, SHIFT, ALT, or META keys, or the arrow keys, do nothing.
			// This lets us support copy and paste too
			if (key == 91 || key > 15 && key < 19 || key >= 37 && key <= 40) {
				return;
			}
			// If that's not a digit (and not backspace or delete) - exit
			if ((key < 48 || key > 57) && !(key == 8 || key == 46)) {
				return;
			}
			if (key === 8) {
				this.format_input_value({ backspace: true });
				event.preventDefault();
				return;
			}
			if (key === 46) {
				this.format_input_value({ delete: true });
				event.preventDefault();
				return;
			}
			// Don't adjust caret position on Backspace (8) and Delete (46) keys
			// (have to do it in a timeout because otherwise changes don't get picked up properly)
			// setTimeout(() => this.format_input_value({ backspace: key == 8, delete: key == 46 }), 0)
			// this.format_input_value({ backspace: key == 8, delete: key == 46 })
		}
	}]);
	return Phone_input;
}(_react2.default.Component); // https://github.com/sanniassin/react-input-mask/blob/master/InputElement.js
// https://github.com/halt-hammerzeit/react-phone-number-input

exports.default = Phone_input;


Phone_input.propTypes = {
	format: _react.PropTypes.object.isRequired,
	value: _react.PropTypes.string.isRequired,
	onChange: _react.PropTypes.func.isRequired,
	className: _react.PropTypes.string,
	style: _react.PropTypes.object
};
module.exports = exports['default'];
//# sourceMappingURL=input.js.map